//@ sourceURL=tabSolicitudInforme.js
/*!
 * Copyright 2021 E.J.I.E., S.A.
 *
 * Licencia con arreglo a la EUPL, Versión 1.1 exclusivamente (la "Licencia");
 * Solo podrá usarse esta obra si se respeta la Licencia.
 * Puede obtenerse una copia de la Licencia en
 *
 *      http://ec.europa.eu/idabc/eupl.html
 *
 * Salvo cuando lo exija la legislación aplicable o se acuerde por escrito,
 * el programa distribuido con arreglo a la Licencia se distribuye "TAL CUAL",
 * SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
 * Véase la Licencia en el idioma concreto que rige los permisos y limitaciones
 * que establece la Licencia.
 */

jQuery(function($) {
	

	initRupI18nPromise.then(function() {
		
		$("#tabDatosBeneficiarios_form_feedback").rup_feedback ({
			  type: "ok",
			  delay: 3000,
			  fadeSpeed: 500,
			  block: false
			});
		
		initComponentes();
		initControDeEstado();
		Ad74aUtils.soloNumericos();
		
	});
	

	function initControDeEstado(){
		
		if(isSoloLecturaSolicitud){

			$("input").prop('disabled', true);
			$("#tabSolicitud_modificarInteresada").hide();
		}
		
	}
	
	function initComponentes(){
		 /******************/
		 /* LLAMADAS UTILS */
		 /******************/
		
		Ad74aUtils.hacerPlegable();
		
		$("#tabSolicitud_form_feedback").rup_feedback(
				{
					type: "ok",
					block: false,
					delay: 3000,
					fadeSpeed: 600,
				}
			);
		
		$('#fRegistro00_tabSolicitud_detail_table').rup_date({
			disabled : isSoloLecturaSolicitud,
			datetimepicker:true,
			placeholderMask : true,
			mask: 'dd-MM-yyyy HH:mm:ss.S',
	        showSecond:true,
			showButtonPanel : true,
			showOtherMonths : true,
	        dateFormat: 'dd/mm/yy',
	        timeFormat: 'HH:mm:ss'
		});


		
		$("#tipoIdentificador01_tabSolicitud_detail_table").rup_combo({
			loadFromSelect:true,
			width: 'auto',
	        ordered: false,
			customClasses: ['select-material'],
			rowStriping: true,
			blank: '',
			onLoadSuccess: function(obj){
//				if(isSoloLecturaSolicitud){
					obj.rup_combo("disable",true);
//				}
			}
		});
		
		// Dirección de notificación
		$("#dirNotcp06_detail_table").on('focusout', () => {
			//$("#tabSolicitud_form").validate().element('#dirNotcp06_detail_table');
//			if($('#dirNotcp06_detail_table').valid() && $("#dirNotcp06_detail_table").val() != $("#dirNotcp06_detail_table").data('prev')){				
			if($("#dirNotcp06_detail_table").val() != $("#dirNotcp06_detail_table").data('prev')){				
				iniciarDireccionNotificacion(
					{
						"idProvincia06": $('#dirNotcp06_detail_table').val().substring(0,2)
					},
					"dirNot"
				);
				$("#dirNotcp06_detail_table").data('prev', $("#dirNotcp06_detail_table").val());
			}						
		});		
		iniciarDireccionNotificacion(expedienteJSON.direccionNotif, "dirNot");
		
		/*
		 * BLOQUE PARA GESTIONAR EL TIPO DE PERSONA DEL REPRESENTANTE
		 */
		$('.personaFisicaGrupo').hide();
		$("#razonSocialGrupo").hide();				
		if($("#tipoIdentificadorRep00_tabSolicitud_detail_table").length > 0){
			let tipoPersona = $("#Jur_tipoRep00_tabSolicitud_detail_table").is(':checked')? tipoPersonaJuridica:tipoPersonaFisica;
			if(tipoPersona == tipoPersonaFisica){
				$('#Fis_tipoRep00_tabSolicitud_detail_table').prop("checked",true);//Chequear radio si no venia chequeado
				$('.personaFisicaGrupo').show();
				$("#razonSocialGrupo").hide();
			}else{
				$('.personaFisicaGrupo').hide();
				$("#razonSocialGrupo").show();
			}
			//Se guarda el valor actual del campo tipoIdentificadorRep00, para setearlo una vez se refresca el combo:
			const _valorTipoIdentificadorRep00 = $("#tipoIdentificadorRep00_tabSolicitud_detail_table").val();
			$("#tipoIdentificadorRep00_tabSolicitud_detail_table").rup_combo({
				source: $.rup.CTX_PATH + 'combo/tipoIdentificador?tipoPersona=' + tipoPersona,
				sourceParam: {label: "descripcion", value:"value"},
				width: 'auto',
		        ordered: false,
				customClasses: ['select-material'],
				rowStriping: true,
				blank: '',
				onLoadSuccess: function(obj){
					//Se vuelve a setear el valor que tenia antes de recargarse:
					$("#tipoIdentificadorRep00_tabSolicitud_detail_table").rup_combo("refresh");
					$("#tipoIdentificadorRep00_tabSolicitud_detail_table").rup_combo("select", _valorTipoIdentificadorRep00);
					if(isSoloLecturaSolicitud){
						$('#tipoIdentificadorRep00_tabSolicitud_detail_table').rup_combo("disable");
					} else{
						$('#tipoIdentificadorRep00_tabSolicitud_detail_table').rup_combo("enable");
					}
				}
			});
		}
		const  fisicaJuridica = () => {
			let tipoPersona = $("#Jur_tipoRep00_tabSolicitud_detail_table").is(':checked')? tipoPersonaJuridica:tipoPersonaFisica;
			if(tipoPersona == tipoPersonaFisica){//Ocultar/mostrar capas en base a la seleccion
				$('.personaFisicaGrupo').show();
				$("#razonSocialGrupo").hide();
			}else{
				$('.personaFisicaGrupo').hide();
				$("#razonSocialGrupo").show();
			}
			if(tipoPersona != undefined && tipoPersona != ''){
				$("#tipoIdentificadorRep00_tabSolicitud_detail_table").rup_combo("setSource", $.rup.CTX_PATH + 'combo/tipoIdentificador?tipoPersona=' + tipoPersona); 
			}else{
				$("#tipoIdentificadorRep00_tabSolicitud_detail_table").rup_combo("setSource", $.rup.CTX_PATH + 'combo/tipoIdentificador'); 
			}
			$("#tipoIdentificadorRep00_tabSolicitud_detail_table").rup_combo("reload");	
		}
		$("[name='tipoRep00']").change(fisicaJuridica);
		if($('#tipoIdentificadorRep00_tabSolicitud_detail_table').val()==null){
			$('#tipoIdentificadorRep00_tabSolicitud_detail_table').prop("disabled",true);
		}
		/* FIN BLOQUE PARA GESTIONAR EL TIPO DE PERSONA DEL REPRESENTANTE */
		
		FN_controlTipoNot00();
		$("[name='idTipoNot00']").change(FN_controlTipoNot00);
		
		FN_controlUrgencia();
		$('#urgencia00_tabSolicitud_detail_table').on("change", FN_controlUrgencia);
		
		FN_controlCanalNot();
		$("[name='canalNot00']").change(FN_controlCanalNot);
		
		
		jQuery.validator.addMethod("direccionNot", function(value, element,a) {
			if(!$("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked')){
				 return true;
			 }			 
			 return value != "" && value != null && value != undefined;			
		 },$.rup.i18n.base.rup_validate.messages.required);
		
		 jQuery.validator.addMethod("requiredPortalNot", function(value, element,a) {
			 if($("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked')){
				 if(element.id == 'dirNotportal06_detail_table' && ($("#dirNotportal06_detail_table").val() == '' || $("#dirNotidportal06_detail_table").rup_combo("getRupValue") != '')){
					 return false;
				 }else if(element.id == 'dirNotidportal06_detail_table' && $("#dirNotidportal06_detail_table").rup_combo("getRupValue") == '' && $("#dirNotportal06_detail_table").val() == '' ){
					 return false;
				 }else {
					 return true;
				 }
			 }			 		 
			 return true;
		 },$.rup.i18n.base.rup_validate.messages.required);
		 
		 jQuery.validator.addMethod("requiredCalleNot", function(value, element,a) {
			 if($("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked')){
				 if(element.id == 'dirNotcalle06_detail_table' && ($("#dirNotcalle06_detail_table").val() == '' || $("#dirNotidcalle06_detail_table").rup_combo("getRupValue") != '')){
					 return false;
				 }else if(element.id == 'dirNotidcalle06_detail_table' && $("#dirNotidcalle06_detail_table").rup_combo("getRupValue") == '' && $("#dirNotcalle06_detail_table").val() == '' ){
					 return false;
				 }else {
					 return true;
				 }
			 }			 
			 return true;
		 },$.rup.i18n.base.rup_validate.messages.required);
		 
		 jQuery.validator.addMethod("requiredCPNot", function(value, element, params) {
			 if($("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked')){
				 if(params.length != 2) {
					 return false;
				 }
				 const current 	= $("[name='"+ params[0]+"']").val();
				 const compareTo = $("[name='"+ params[1]+"']").val();
				 return (current!= "" && compareTo == "") || compareTo != "";	
			 }
			 return true;
		 }, $.rup.i18n.base.rup_validate.messages.required);
		 jQuery.validator.addMethod("validarNivelUrgencia", function(value, element,a) {
			 return   ($("#urgencia00_tabSolicitud_detail_table").is(':checked') && $("#urgenciaDetailPapel0").rup_combo("getRupValue") != '') || !($("#urgencia00_tabSolicitud_detail_table").is(':checked')  || $("#urgenciaDetailPapel0").rup_combo("getRupValue") != '')  ;  
		 }, $.rup.i18n.app.errores.nivelUrgencia);
		 var properties={
				feedback:$("#tabSolicitud_form_feedback"),
				liveCheckingErrors: false,
				showFieldErrorAsDefault: true,
				showErrorsInFeedback: true,
				showFieldErrorsInFeedback: true,
			  rules:{
				  "direccionNotif.cp06":{ direccionNot : true},
				  "direccionNotif.provincia06":{ direccionNot : true},
				  "direccionNotif.idProvincia06":{ direccionNot : true},
				  "direccionNotif.municipio06":{ direccionNot : true},
				  "direccionNotif.idMunicipio06":{ direccionNot : true},
//				  "direccionNotif.localidad06":{ /*requiredNot : true,*/requiredCPNot: ["direccionNotif.localidad06", "direccionNotif.idLocalidad06"]},
//				  "direccionNotif.idLocalidad06":{ /*requiredNot : true,*/requiredCPNot: ["direccionNotif.idLocalidad06", "direccionNotif.localidad06"]},
				  "direccionNotif.calle06":{ requiredCalleNot : true,requiredCPNot: ["direccionNotif.calle06", "direccionNotif.idCalle06"]},
				  "direccionNotif.idCalle06":{requiredCalleNot : true ,requiredCPNot: ["direccionNotif.idCalle06", "direccionNotif.calle06"]},
				  "direccionNotif.portal06":{requiredPortalNot : true ,requiredCPNot: ["direccionNotif.portal06", "direccionNotif.idPortal06"] },
				  "direccionNotif.idPortal06":{ requiredPortalNot : true, requiredCPNot: ["direccionNotif.idPortal06", "direccionNotif.portal06"]},
			      "emailNot00":{email:true},
				  "urgencia00":{ validarNivelUrgencia:true},
				  "idiomaNot00":{required:true},
			 },
		};
		$("#tabSolicitud_form").rup_validate(properties);
		
		//Se eliminan estos imput que se generan en los checkbox que entran en conflicto con los estilos (no pone en noglo el texto del label)
		$("input[name='_urgencia00']").remove();

		/*****************/
		 /* BOTON GUARDAR */
		 /*****************/
		// GUARDAR
	    $("#tabSolicitud_guardar").on("click", function(){
	    	if($("#tabSolicitud_form").valid()){
	    		
	    		
	    		Ad74aUtils.cerrarFeedbacks();
		    	$("#tabSolicitud_form").rup_validate("resetElements");
		    	let data = {};
		    	data = $("#tabSolicitud_form").rup_form("formToJson");
		    	
		    	
		    	var msgErrorInicio = "<ul class='rup-maint_feedbackUL'><br/>";
		    	var msgErrorFin = '</ul>';
		    	var msgError = '';
		    	
		    	if(msgError == ''){
		    		$.rup_ajax({
			    		 type:  "PUT",
			   	         url: $.rup.CTX_PATH + 'expedientes/edit',
			   	         data: JSON.stringify(data),
			             contentType: 'application/json',
			             beforeSend: function(){
			            	Ad74aUtils.cerrarFeedbacks();
							Ad74aUtils.bloquearInterfaz();
						},
		   			success: function(res){
		   				$("#tabSolicitud_form_feedback").rup_feedback('set',$.rup.i18n.app.feedback.modificadoOK,'ok');
		   				},
							error: function(error){
								$("#tabSolicitud_form_feedback").rup_feedback('set',error.responseText,"error");
							},
							complete: function(){
								Ad74aUtils.desBloquearInterfaz();
							}
			   	    });
		    	}else{

					$("#tabSolicitud_form_feedback").rup_feedback('set',msgErrorInicio+msgError+msgErrorFin,"error");
		    	}
		    	
	    	}
	    	
	    });
	    
	    /* **************************** */
		/* MODIFICAR PERSONA INTERESADA */
		/* **************************** */
		$("#cambiarIntersesada_dialog_feedback").rup_feedback ({
			  type: "ok",
			  delay: 3000,
			  fadeSpeed: 500,
			  block: false
		});
		Ad74aUtils.configCombo($("#urgenciaDetailPapel0"), {
			loadFromSelect: true,
			ordered: true,
			onLoadSuccess: (obj) => {	
				if(isSoloLecturaSolicitud){
					obj.rup_combo("disable",true);
				}
				setTimeout(() => {					
					//$("#urgenciaDetailPapel0").rup_combo("setRupValue", urgenciaInforme);
					$("#urgenciaDetailPapel0").rup_combo("refresh");
					if(isSoloLecturaSolicitud){
						obj.rup_combo("disable",true);
					}
					
				}, 300);
			}
		});
		$("#tipoIdentificador01_cambiarInteresada_detail").rup_combo({
			loadFromSelect:true,
			width: 'auto',
	        ordered: false,
			customClasses: ['select-material'],
			rowStriping: true,
			blank: '',
			disabled:true
		});
		
		$("#sexo01_cambiarInteresada_detail").rup_combo({
			loadFromSelect:false,
			width: 'auto',
	        ordered: false,
			customClasses: ['select-material'],
			rowStriping: true,
			blank: ''
		});
		
		$("#tipoIdentificador01_cambiarInteresada_cambio").rup_combo({
			loadFromSelect:true,
			width: 'auto',
	        ordered: false,
			customClasses: ['select-material'],
			rowStriping: true,
			blank: '',
			onLoadSuccess: function(obj){
			},
			selected: (function(){ try { return $("#tipoIdentificador01_cambiarInteresada_cambio").val()} catch { return null}})()
		});
		
		$("#sexo01_cambiarInteresada_cambio").rup_combo({
			loadFromSelect:false,
			width: 'auto',
	        ordered: false,
	        disabled:true,
			customClasses: ['select-material'],
			rowStriping: true,
			blank: ''
		});
		
		$("#apellido101_tabSolicitud_detail_table").prop("disabled", true);
	    $("#apellido201_tabSolicitud_detail_table").prop("disabled", true);
	    $("#nombre01_tabSolicitud_detail_table").prop("disabled", true);
//	    $("#tipoIdentificador01_tabSolicitud_detail_table").rup_combo("disable", true);
	    $("#identificador01_tabSolicitud_detail_table").prop("disabled", true);
	    $("#H_sexo01_tabSolicitud_detail_table").prop("disabled", true);
	    $("#M_sexo01_tabSolicitud_detail_table").prop("disabled", true);
		    
		jQuery.validator.addMethod("validarIdentificadorCambiarInteresada", function(value, element,a) {
			 return Ad74aUtils.validarCampoIdentificador($("#tipoIdentificador01_cambiarInteresada_cambio").val(),$("#identificador01_cambiarInteresada_cambio").val());	
		 }, $.rup.i18n.app.errores.dniNoValido);
		 
		 var propertiesCambiarInteresada={
				feedback:$("#cambiarIntersesada_dialog_feedback"),
				liveCheckingErrors: false,
				showFieldErrorAsDefault: true,
				showErrorsInFeedback: true,
				showFieldErrorsInFeedback: true,
				rules:{
					  "apellido101":{ required:true},
					  "nombre01":{ required:true},
					  "sexo01":{ required:true},
					  "tipoIdentificador01":{ required:true},
					  "identificador01":{ required:true, validarIdentificadorCambiarInteresada:true},
				}
		};
		 
		$("#cambiarInteresada_form").rup_validate(propertiesCambiarInteresada);
		
		$("#dialogCambiarInteresada").rup_dialog({
			type: $.rup.dialog.DIV,
			autoOpen: false,
			modal: true,
			closeOnEscape: true,
			resizable: true,
			//width:600,
			height:1300,
			dialogClass: 'custom_mid_dialog',
			title: $.rup.i18n.app.dialog.title.cambioTit,
			buttons : [ 
                {
                    text:$.rup.i18n.app.botonera.guardarDatosInterop,
                    id:"cambiarInteresada_aceptar_btn",
                    class: 'btn-material btn-material-primary-high-emphasis',
                    click:  () => {
                    	 let solicitanteData = $("#cambiarInteresadaInterop").rup_form("formToJson"); // Datos del formulario Solicitante
                         let representanteData = null;

                         if ($("#cambiarRepresentante").is(":checked")) {
                             representanteData = $("#cambiarRepresentanteNuevo").rup_form("formToJson"); // Datos del formulario RepresentanteNuevo
                         }

                         let mensaje = $.rup.i18n.app.confirm.cambiarInteresada;

                         let representante = null;
                         if (representanteData) {
                             representante = representanteData;
                             mensaje = $.rup.i18n.app.confirm.cambiarConRepre;;
                         }
                         
                         Ad74aUtils.openConfirmDialog(
                 				'dialogConfirm', 
                 				$.rup.i18n.app.dialog.title.cambioTit, 
                 				mensaje,  
                 				[
                 		        	{
                 		                text: $.rup.i18n.app.botonera.cancelar,
                 		                click: function () { 
                 		                    $('#dialogConfirm').rup_dialog('close'); 
                 		                },
                 		                btnType: $.rup.dialog.LINK
                 		            },
                 			        {
                 			            text: $.rup.i18n.app.botonera.aceptar,
                 			            id: "btnAceptar",
                 			            class: 'btn-material btn-material-primary-high-emphasis',
                 			            click: function () { 
                 			            	 $('#dialogConfirm').rup_dialog('close'); 
                 			            	 // Llamada AJAX
                 	                         $.rup_ajax({
                 	                             url: $.rup.CTX_PATH + "solicitantes/cambiarPersonaInteresada",
                 	                             type: "POST",
                 	                             contentType: "application/json",
                 	                             data: JSON.stringify({
                 	                                 solicitantes: solicitanteData,
                 	                                 representante: representante,
                 	                                 idExpediente: idExpediente00
                 	                             }),
                 	                             success: function (data) {
                 	                                 $("#dialogCambiarInteresada").rup_dialog("close");
                 	                                 Ad74aUtils.desBloquearInterfaz();
                 	                                 $("#tabSolicitud_form_feedback").rup_feedback('set', $.rup.i18n.app.feedback.operacionOK, "ok");
                 	                                 location.reload();
                 	                             },
                 	                             beforeSend: function () {
                 	                                 Ad74aUtils.cerrarFeedbacks();
                 	                                 Ad74aUtils.bloquearInterfaz();
                 	                             },
                 	                             error: function (data) {
                 	                                 Ad74aUtils.desBloquearInterfaz();
                 	                                 $("#cambiarIntersesada_dialog_feedback").rup_feedback('set', data.responseText, "error");
                 	                             }
                 	                         });
                 			            }
                 			        }
                 		        ]);
                         
                        
 					}
                 },
				{
					text : $.rup.i18n.app.botonera.cancelar,
					click : () => {
						$("#dialogCambiarInteresada").rup_dialog("close");
					},
					btnType : $.rup.dialog.LINK
				}
			],
			open: function(){
			},
			close: function(){
				$("#cambiarIntersesada_dialog_feedback").rup_feedback("close");
			}		    
		});
		
		$("#tabSolicitud_modificarInteresada").rup_button({
			click: function(){
				$("#identificador01_cambiarInteresada_detail").val('');
                $("#nombre01_cambiarInteresada_detail").val('');
                $("#apellido101_cambiarInteresada_detail").val('');
                $("#apellido201_cambiarInteresada_detail").val('');
                $("#fNacimiento01_cambiarInteresada_detail").val('');
                $("#sexo01_cambiarInteresada_detail").rup_combo("select", '');
                
                //Vamos a sobreescribir los datos del dialog para que muestre los de la persona interesada al abrir 
                
                $('#apellido101_cambiarInteresada_cambio').val($('#apellido101_tabSolicitud_detail_table').val());
                $('#apellido201_cambiarInteresada_cambio').val($('#apellido201_tabSolicitud_detail_table').val());
                $('#nombre01_cambiarInteresada_cambio').val($('#nombre01_tabSolicitud_detail_table').val());
                $("#sexo01_cambiarInteresada_cambio").rup_combo("select", 'input[name="solicitantes.sexo01"]:checked');
                $('#fNacimiento01_cambiarInteresada_cambio').val($('#fNacimiento01_tabSolicitud_detail_table').val());
                $('#identificador01_cambiarInteresada_cambio').val($('#identificador01_tabSolicitud_detail_table').val());
				
                
                
                //Comprobamos que el representante este si no esta no mostramos el div
                if ($('#R_presentaSol00_tabSolicitud_detail_table').is(':checked')) {
	                $("#representanteActual").removeAttr("hidden"); // Muestra el div
		            $("#cambiarRepresentanteInterop").show(); // Muestra el form
		            $("#botonCambiarRepresentante").removeAttr("hidden");
                }
	            
                // Datos de representante                 
                
                $("#apellido101_cambiarRepresentante_detail").val($("#apellido1Rep00_tabSolicitud_detail_table").val() || "");
                $("#apellido201_cambiarRepresentante_detail").val($("#apellido2Rep00_tabSolicitud_detail_table").val() || "");
                $("#nombre01_cambiarRepresentante_detail").val($("#nombreRep00_tabSolicitud_detail_table").val() || "");
                $("#identificador01_cambiarRepresentante_detail").val($("#identificadorRep00_tabSolicitud_detail_table").val() || "");
                $("#sexo01_cambiarRepresentante_detail").val($("#M_sexoRep00_tabSolicitud_detail_table").val() || $("#M_sexoRep00_tabSolicitud_detail_table").val() || "");

                
                
                $("#apellido101_cambiarRepresentanteNuevo_detail").val("");
                $("#apellido201_cambiarRepresentanteNuevo_detail").val("");
                $("#nombre01_cambiarRepresentanteNuevo_detail").val("");
                $("#sexo01_cambiarRepresentanteNuevo_detail").val("");
                $("#identificador01_cambiarRepresentanteNuevo_detail").val("");
                
                //Abrimos el dialog y llamamos a NISAE 
                
                $("#dialogCambiarInteresada").rup_dialog("open");
				FN_recibirDatosUsuario_NISAE();
			}
		});
	}
	
	function FN_controlTipoNot00(){
		if($("#T_idTipoNot00_tabSolicitud_detail_table").is(':checked')){
			
			FN_controlCanalNot();
			
			$("#divDireccionNot").hide();
			$('#dirNotcp06_detail_table').removeAttr("required");
			$('#dirNotidprovincia06_detail_table').removeAttr("required");
			$('#dirNotidmunicipio06_detail_table').removeAttr("required");
			$('#dirNotidlocalidad06_detail_table').removeAttr("required");

			
		}else if($("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked')){
			
			FN_controlCanalNot();
			
			$("#divDireccionNot").show();
			$('#dirNotcp06_detail_table').attr("required","required");
			$('#dirNotidprovincia06_detail_table').attr("required","required");
			$('#dirNotidmunicipio06_detail_table').attr("required","required");
			//$('#dirNotidlocalidad06_detail_table').attr("required","required");

		}
		
	}
	function FN_controlVisivilidadIdiomaNot00(){
		if($("#OTROS_idiomaNot00_tabSolicitud_detail_table").prop("checked")){
			$("#divOtroIdiomaNot00").show();
		}else{
			$("#divOtroIdiomaNot00").hide()
		}
	}
	
	function FN_controlUrgencia() {
	    // Comprobamos si el checkbox está seleccionado
	    if ($('#urgencia00_tabSolicitud_detail_table').is(':checked')) {
	        // Si el checkbox está seleccionado, mostramos el select
	        $('#urgenciaLayer').show();
	    } else {
	        // Si no está seleccionado, ocultamos el select
	        $('#urgenciaLayer').hide();
	        if($("#urgenciaDetailPapel0").val() != ''){
	        	 $("#urgenciaDetailPapel0").rup_combo("clear");
	        }
	       
	    }
	}
	
	function FN_controlCanalNot(){
		
		if($("#A_canalNot00_tabSolicitud_detail_table").is(':checked')){
			$("#tlfnNotGrupo").show();
			$("#emailNotGrupo").show();
		}if($("#E_canalNot00_tabSolicitud_detail_table").is(':checked')){
			$("#emailNotGrupo").show();
			$("#tlfnNotGrupo").hide();
		}if($("#S_canalNot00_tabSolicitud_detail_table").is(':checked')){
			$("#tlfnNotGrupo").show();
			$("#emailNotGrupo").hide();
		}
		
	}
	
const iniciarDireccionNotificacion = (direccion, prefix) => {
		
		// Mostrar/ocultar los datos alternativos inicialmente
		if($("#"+prefix+"idlocalidad06_detail_table").val() == ''){						
			$("#"+prefix+"localidadDesc").show();
			$("#"+prefix+"calleDesc").show();
			$("#"+prefix+"portalDesc").show();
		}else{
			$("#"+prefix+"localidadDesc").hide();
		}
		
		if($("#"+prefix+"idcalle06_detail_table").val() == ''){						
			$("#"+prefix+"calleDesc").show();
			$("#"+prefix+"portalDesc").show();
		}else{
			$("#"+prefix+"calleDesc").hide();
		}
		
		if($("#"+prefix+"idportal06_detail_table").val() == ''){
			$("#"+prefix+"portalDesc").show();
		}else{
			$("#"+prefix+"portalDesc").hide();
		}
		
		// Iniciar el componente dirección de contacto
	//	console.log("Iniciar el componente");
	//	console.log(direccion);
		initDirComponent({
			"prefix": prefix,
			"direccion": direccion, 
			"pisoTutelado": false,
			"provinciasNoCAV":true,
			"callbacks": {
				"general": {
					"success": () => {}
				},
				"provincia": {
					"change": () => {},
					"success": () => {						
	
						if(isSoloLecturaSolicitud){
							$("#"+prefix+"idprovincia06_detail_table").rup_combo("disable");
						}
					},
					"selected": () => {
						console.log("provincia seleccionada: " + direccion.idProvincia06);
						return direccion.idProvincia06;
					}
				},
				"municipio": {
					"change": () => {},
					"success": () => {
						const allOptions = $("#"+prefix+"idmunicipio06_detail_table option");
						const opts = allOptions.filter( idx => allOptions[idx].value);
						if(opts.length == 1) {
							console.log("dentro municipio");
							direccion.idMunicipio06 = opts[0].value;
							console.log(direccion.idMunicipio06);
							$("#"+prefix+"idmunicipio06_detail_table").rup_combo("select", opts[0].value);
						}
						if(isSoloLecturaSolicitud){
							$("#"+prefix+"idmunicipio06_detail_table").rup_combo("disable");
						}
					},
					"selected": () => {
						const allOptions = $("#"+prefix+"idmunicipio06_detail_table option");
						const opts = allOptions.filter( idx => allOptions[idx].value);
						if(opts.length == 1) {
							return opts[0].value;
						}
						return direccion.idMunicipio06;
					}
				},
				"localidad": {
					"change": () => {
							// TODO: refrescar pisostutelados	
						
						if($("#"+prefix+"idlocalidad06_detail_table").rup_combo("value") == ''){						
							$("#"+prefix+"localidadDesc").show();
							$("#"+prefix+"calleDesc").show();
							$("#"+prefix+"portalDesc").show();
						}else{
							$("#"+prefix+"localidadDesc").hide();
						}
					},
					"success": () => {
						if(isSoloLecturaSolicitud) {
							$("#"+prefix+"idlocalidad06_detail_table").rup_combo("disable");
							$("#"+prefix+"localidadDesc").prop("disabled", false);							
						}
						
						const allOptions = $("#"+prefix+"idlocalidad06_detail_table option");
						const opts = allOptions.filter( idx => allOptions[idx].value);
						if(opts.length == 1) {				
							direccion.idLocalidad06 = opts[0].value;
							$("#"+prefix+"idlocalidad06_detail_table").rup_combo("select", opts[0].value);
						}
						
						if($("#"+prefix+"idlocalidad06_detail_table").rup_combo("value") == ''){						
							$("#"+prefix+"localidadDesc").show();
							$("#"+prefix+"calleDesc").show();
							$("#"+prefix+"portalDesc").show();
						}else{
							$("#"+prefix+"localidadDesc").hide();
						}
						
					},
					"selected": () => {
						const allOptions = $("#"+prefix+"idlocalidad06_detail_table option");
						const opts = allOptions.filter( idx => allOptions[idx].value);
						if(opts.length == 1) {				
							return opts[0].value;
						}
						return direccion.idLocalidad06;
					}
				},
				"calle": {
					"change": () => {						
						// TODO: refrescar pisostutelados	
						
						if($("#"+prefix+"idcalle06_detail_table").rup_combo("value") == ''){
							$("#"+prefix+"calleDesc").show();
							$("#"+prefix+"portalDesc").show();
						}else{
							$("#"+prefix+"calleDesc").hide();
						}
					},
					"success": () => {
						if(isSoloLecturaSolicitud) {
							$("#"+prefix+"idcalle06_detail_table").rup_combo("disable");
							$("#"+prefix+"calle06_detail_table").prop("disabled", true);
						}
						
						const allOptions = $("#"+prefix+"idcalle06_detail_table option");
						const opts = allOptions.filter( idx => allOptions[idx].value);
						if(opts.length == 1 && $("#"+prefix+"calle06_detail_table").val() == '' ) {				
							direccion.idCalle06 = opts[0].value;
							$("#"+prefix+"idcalle06_detail_table").rup_combo("select", opts[0].value);
						}
						
					},
					"selected": () => {
						const allOptions = $("#"+prefix+"idcalle06_detail_table option");
						const opts = allOptions.filter( idx => allOptions[idx].value);
						if(opts.length == 1) {				
							return opts[0].value;
						}
						return direccion.idCalle06;
					}
				},
				"portal": {
					"change": () => {						
						// TODO: refrescar pisostutelados	
						
						if($("#"+prefix+"idportal06_detail_table").rup_combo("value") == ''){
							$("#"+prefix+"portalDesc").show();
						}else{
							$("#"+prefix+"portalDesc").hide();
						}
						if($("#"+prefix+"cp06_detail_table").val()=='' && $("#"+prefix+"idportal06_detail_table") != ''){
							const ajaxData = {
									'url': $.rup.CTX_PATH + 'nora/conseguirCP?portal='+ $("#"+prefix+"idportal06_detail_table").val() ,
									'type': 'GET',
									'contentType': 'application/json',
									'dataType': 'json',
									success: function (res) {
										$("#"+ prefix + "cp06_detail_table").val(res);
									},
									error: function (error) {
										//$("#iniciosOficio_feedback").rup_feedback('set', error.responseText, "error");	
									}
								};
								
							$.rup_ajax(ajaxData);
						}
					},
					"success": () => {						
						if(isSoloLecturaSolicitud) {
							$("#"+prefix+"idportal06_detail_table").rup_combo("disable");
							$("#"+prefix+"portal06_detail_table").prop("disabled", true);
						}
						
						const allOptions = $("#"+prefix+"idportal06_detail_table option");
						const opts = allOptions.filter( idx => allOptions[idx].value);
						if(opts.length == 1  && $("#"+prefix+"portal06_detail_table").val() == ''  ) {				
							direccion.idPortal06 = opts[0].value;
							$("#"+prefix+"idportal06_detail_table").rup_combo("select", opts[0].value);
						}
					},
					"selected": () => {
						const allOptions = $("#"+prefix+"idportal06_detail_table option");
						const opts = allOptions.filter( idx => allOptions[idx].value);
						if(opts.length == 1) {				
							return opts[0].value;
						}
						return direccion.idPortal06;
					}
				}
			}
		});
}
});